=== debian/changelog ===
gogglesmm (1.2.2-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Wed, 04 Aug 2021 18:06:54 -0400

gogglesmm (1.2.2-0ppa1~bionic1~ubuntu21.04.1~ppa1) hirsute; urgency=medium

  * No-change backport to hirsute

 -- Sander Jansen <s.jansen@gmail.com>  Sun, 03 Jan 2021 12:41:54 -0600

gogglesmm (1.2.2-0ppa1~bionic1) bionic; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Sun, 27 Dec 2020 15:47:21 -0600

gogglesmm (1.2.1-0ppa1~bionic1) bionic; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Tue, 31 Jul 2018 19:05:31 -0500

gogglesmm (1.2.0-0ppa1~bionic1) bionic; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Wed, 04 Jul 2018 02:02:19 -0500

gogglesmm (1.1.8-0ppa1~xenial1) xenial; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Tue, 11 Apr 2017 20:46:23 -0500

gogglesmm (1.1.7-0ppa1~xenial1) xenial; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Tue, 28 Mar 2017 21:25:34 -0500

gogglesmm (1.1.6-1ppa1~xenial1) xenial; urgency=medium

  * Fix build options

 -- Sander Jansen <s.jansen@gmail.com>  Wed, 08 Feb 2018 09:08:00 -0600

gogglesmm (1.1.6-0ppa1~xenial1) xenial; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Tue, 07 Feb 2017 19:58:31 -0600

gogglesmm (1.1.5-0ppa1~xenial1) xenial; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Sun, 01 Jan 2017 01:15:35 -0600

gogglesmm (1.1.4-0ppa1~xenial1) xenial; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Fri, 23 Dec 2016 12:25:01 -0600

gogglesmm (1.1.3-0ppa1~xenial1) xenial; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Sat, 22 Oct 2016 12:18:54 -0500

gogglesmm (1.1.2-0ppa1~xenial1) xenial; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Thu, 20 Oct 2016 10:38:20 -0500

gogglesmm (1.1.1-0ppa1~xenial1) xenial; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Thu, 29 Sep 2016 21:03:24 -0500

gogglesmm (1.1.0-0ppa1~xenial1) xenial; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Sat, 17 Sep 2016 17:21:18 -0500

gogglesmm (1.0.18-0ppa3~xenial1) xenial; urgency=medium

  * Drop cmake to 3.2.2 to support backport to trusty

 -- Sander Jansen <s.jansen@gmail.com>  Sat, 06 Aug 2016 13:19:29 -0500

gogglesmm (1.0.18-0ppa2~xenial1) xenial; urgency=medium

  * Require cmake 3.3.1

 -- Sander Jansen <s.jansen@gmail.com>  Fri, 05 Aug 2016 22:39:00 -0500

gogglesmm (1.0.18-0ppa1~xenial1) xenial; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Fri, 05 Aug 2016 21:28:52 -0500

gogglesmm (1.0.14-0ppa1~trusty1) trusty; urgency=medium

  * New upstream release.

 -- Sander Jansen <s.jansen@gmail.com>  Mon, 30 May 2016 12:17:12 -0500

gogglesmm (1.0.12-0ppa3~trusty1) trusty; urgency=medium

  * Rebuild for FOX 1.7.55

 -- Sander Jansen <s.jansen@gmail.com>  Sat, 21 May 2016 22:47:58 -0500

gogglesmm (1.0.12-0ppa2~trusty1) trusty; urgency=low

  * Fix package dependencies

 -- Sander Jansen <s.jansen@gmail.com>  Fri, 13 May 2016 21:55:01 -0500

gogglesmm (1.0.12-0ppa1~trusty1) trusty; urgency=low

  * Initial release 

 -- Sander Jansen <s.jansen@gmail.com>  Fri, 29 Apr 2016 13:44:42 -0500
