=== debian/control ===
Source: gogglesmm
Section: sound
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Sander Jansen <s.jansen@gmail.com>
Build-Depends: debhelper (>= 9),
	       cmake (>= 3.2.2),
	       libx11-dev,
	       libxft-dev,
               libxrandr-dev, 
               libxfixes-dev,
               libxcursor-dev, 
               libice-dev,
               libsm-dev,
               libgl-dev,
               libz-dev,
               libbz2-dev,
               libpng-dev,
               libjpeg-dev,
               libwebp-dev,
               libtiff-dev,
	       libsqlite3-dev (>= 3.6.19),
	       libtag1-dev (>= 1.9.0),
	       libdbus-1-dev,
	       libasound2-dev,
	       libpulse-dev,
	       libogg-dev,
	       libvorbis-dev,
	       libopus-dev,
	       libflac-dev,
	       libmad0-dev,	
	       libfaad-dev,
	       libepoxy-dev,
	       libssl-dev,
	       libexpat1-dev,
	       libglu1-mesa-dev				
Standards-Version: 3.9.7
Homepage: https://gogglesmm.github.io
Vcs-Git: https://github.com/gogglesmm/gogglesmm.git

Package: gogglesmm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: python2
Description: Goggles Music Manager
 Music Manager and Player
