=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=-format

%:
	#dh $@  --with autotools-dev
	dh $@ --buildsystem=cmake

override_dh_strip:
	dh_strip --no-automatic-dbgsym

#override_dh_auto_configure:
#	dh_auto_configure $@ --buildsystem=cmake -- -DWITH_OPENSSL=OFF
